/**
	SoundManager class
	JDG Communications for Federal Trade Commission
*/

import mx.utils.Delegate;
import gs.TweenLite;
import gov.ftc.core.Utilities;
import gov.ftc.squaresgame.templates.BasicClip;

class gov.ftc.squaresgame.SoundManager extends BasicClip {

// CLASS VARIABLES

	private var __gc:MovieClip;  // gameController
	private var __inited:Boolean;
	
	private var __sounds:Array;
	
	// for each sound	
	private var applause1:Sound;
	private var applause2:Sound;
	private var chime1:Sound;
	private var chime2:Sound;
	private var chime3:Sound;
	private var end_mix01:Sound;
	private var groan1:Sound;
	private var groan2:Sound;
	private var laugh1:Sound;
	private var laugh2:Sound;
	private var laugh3:Sound;
	private var laugh4:Sound;
	
	private var loop_mix1:Sound;
	
	private var laughBank:Array;
	private var applauseBank:Array;
	
	private var __mcDepth:Number;

// CONSTRUCTOR
	
	public function SoundManager() {
		super();
		this.__inited = false;
		setData("soundManager");
		__mcDepth = 10;
		init();
	}
	
// CLASS METHODS

	private function init():Void {
	
		if (!this.__inited) {
			this.__inited = true;
			for (var i:String in this.__gd.sounds) {
				var objRef:Object = this.__gd.sounds[i];
				if (objRef.src) {
					var d:Number = newDepth();
					var mc:MovieClip = createEmptyMovieClip('mc_' + d, d);
					this[i] = new Sound(mc);
					if (!objRef.external) {
						this[i].attachSound(objRef.src);
					} else {
						
					}
				}
			}
		}
		laughBank = ['laugh1', 'groan1', 'laugh2', 'groan2', 'laugh3', 'laugh4'];
		applauseBank = ['applause1', 'applause2'];
	}
	
	public function playBankSound(p_bank:String, p_pan:Number, p_volume:Number):Void {
		var s:String = this[p_bank].shift();
		this[p_bank].push(s);
		playSound(s, false, p_pan, p_volume);
	
	}
	
	public function playSound(p_sound:String, p_looping:Boolean, p_pan:Number, p_volume:Number):Void {
		if (p_pan != undefined && p_pan != null) {
			var p:Number = p_pan * (__gd.maxPanExtent/100);
			this[p_sound].setPan(p_pan);
		}
		if (p_volume != undefined && p_volume != null) {
			this[p_sound].setVolume(p_volume);
		}
		if (p_looping) {
			this[p_sound].start(0, 9999);
		} else {
			this[p_sound].start();
		}
	}
	
	public function fadeSound(p_sound:String, p_fadeTime:Number, p_endVolume:Number):Void {
		TweenLite.to(this[p_sound], p_fadeTime, {volume: p_endVolume});
	}
	
	public function stopSound(p_sound:String):Void {
		this[p_sound].stop();
	}
	
	private function newDepth():Number {
		return __mcDepth++;
	}

	public function destroy():Void {
		for (var i:String in this.__gd.sounds) {
			this.__gd.sounds[i].stop();
		}
	}
}